problem = ThreeGraphAxiomsProblem(6, forbid="5:123124125345")
problem.set_inactive_types(0, 4)
problem.make_codegree_problem(1/3)
problem.set_inactive_densities(0, 14, 18, 21, 25, 43, 45, 49, 50, 52, 54, 88, 89, 90, 106, 128, 136, 152, 153)
construction = ThreeGraphBlowupConstruction("3:112223331", phantom_edge=(1, 2, 3))
problem.set_extremal_construction(construction)
problem.add_zero_eigenvectors(1, vector(QQ,[0,0,0,3,4,-2,-1,-2,-1,-1,2,0]))
problem.add_zero_eigenvectors(2, vector(QQ,[0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1]))
problem.solve_sdp(True, solver="sdpa_dd", tolerance=1e-8)
problem.make_exact(2^30)
problem.write_certificate("F32Codegree.sage")

# verifying that each alpha_i is non-positive
print [alpha for alpha in problem._bounds if alpha>0]

# checking that M_2="5:123(2)" has non-zero coefficient
print "M_2=",problem._axiom_flags[0][1]
# note that the negated values of c_j are stored
print "c_2=",-problem._exact_density_coeffs[1]

# comparing the number of sharp 3-graphs
print len(problem._sharp_graphs)
# and of those that appear in T_{A,B,C} + tripartite edge
print len(construction.subgraphs(6))

# verifying the rank condition for type tau_6
print problem.types[5]
print problem._exact_Q_matrices[5].nrows()
print problem._exact_Q_matrices[5].rank()
